﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MiniStm32JoeC_CoreLibrary {
    public enum ConnectionType {
        Undefined = 0,
        Serial_RS232_UART,
        USB_HID
    }
    public enum PinMode {
        Undefined,
        IF_In_Floating,
        IP_In_PullUp,
        ID_In_PullDown,
        IA_In_Analog,
        OP_Out_PushPull,
        OD_Out_OpenDrain,
        AP_Alt_PushPull,
        AD_Alt_OpenDrain,
    }
    public enum PinSetState {
        Undefined,
        PinState_In_Float = '0',
        PinState_PP_Low = '1',
        PinState_PP_High = '2',
        PinState_In_PDown = '3',
        PinState_In_PUp = '4',
        PinState_In_Analog = '5',
        PinState_OD_Low = '6',
        PinState_OD_High = '7',
        PinState_AP_Low = '8',
        PinState_AP_High = '9',
        PinState_AD_Low = 'A',
        PinState_AD_High = 'B',
    }
    public enum PinLogicalState {
        Undefined,
        High,
        Low
    }
    public enum PinHwSpeed {
        Undefined,
        Mhz_2,
        Mhz_10,
        Mhz_50
    }
    public enum Mode_Get {
        NoRequest = 0,
        GetBoardId = 1,
        GetGPIOConfig = 2,
        GetPinDigital = 3,
        GetAdcSingle = 4,
        GetModeSetGet = 5,
        GetMotionStatus = 6,
        GetADCPinArrayCfg = 7,
        GetADCPinArray = 8,
        GetI2c1Debug = 9,
        GetI2c1Rx = 10,
        GetSpi1Rx = 11,
        GetSpiConf = 12,
        Uart1Rx = 13,
        Uart3Rx = 14,

        //auto assigned by board
        BusyI2c1Trans = 110
    }
    public enum Mode_Set { 
        NoRequest = 0,
        SetModeGet = 1,
        SetPinLine = 2,
        //3 debug
        SetI2cRead = 4,
        SetSoftwareReset = 5,
        SetMoveSteps = 6,
        SetMoveHoming = 7,
        SetAdcPinArray = 8,
        SetMasterSenseLines = 9,
        SetUart1TxDma = 10,
        WS2812_WriteAll_SingleColor = 11,
        WS2812_rainbow_Loop = 12,
        WS2812_WriteAll_Off = 13,
        WS2812_WriteAll_MultiColor = 14,
        SetUart3TxDma = 15,
        SetSpiTX8 = 16,
        SetSpiTX16 = 17,
        SetSpiTX32 = 18,
        SetSpiTarget = 19,
        SPI1_MasterConfig = 20,
        InitUartBaudrate = 21,
        SetSpiCsPinArray = 22,
        I2CA_RequestRead = 23,
        I2CA_RequestWrite = 24,
        I2CA_RequestWriteRead = 25,
        I2CA_RequestScanSlaves = 26,
        I2CA_Setup_Async = 27,
        I2CA_RequestWriteRead2 = 28,

        //auto assigned by board
        AdcPinArraySet = 100,
        AdcPinArrayDone = 101,
        AdcMaSense = 102,
        AdcMaSenseDone1 = 103,
        AdcMaSenseDone2 = 104,
        AdcMaSenseDone3 = 105,
        AdcMaSenseDone4 = 106,
        //107 - 109
        MotionMove = 110,
        MotionIsMoving = 111,
        MotionHomeSearch = 112,
        MotionHomeToPos = 113,
        MotionHomeFailed = 114,
        //115 - 119
        BusySpiTrans = 120,
        BusySpiResponse = 121,
        SpiNotInitialised = 122,
        //123, 124
        BusyI2CTrans = 125,
        BusyI2CResponse = 126
    }

}
