﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MiniStm32JoeC_CoreLibrary.Components
{
    public partial class SubUC_Color : UserControl, iSubUcItems {
        MiniStm32BoardJoeC _board;
        int _ledIndex = 0;
        public SubUC_Color(MiniStm32BoardJoeC referenceBoard, string[] para) {
            InitializeComponent();
            _board = referenceBoard;
            //0=cmd,1=loc,2=label,3=pin,4=secondPara
            txt_Label.Text = para[2];
            int.TryParse(para[3], out _ledIndex);
            txt_LedIndex.Text = para[3];
        }
        public string GetSetting() {
            byte[] C = new byte[] { label_color.BackColor.R, label_color.BackColor.G, label_color.BackColor.B };
            //0=cmd,1=loc,2=label,3=pin,4=secondPara
            return $"COL#{Location.X}:{Location.Y}#{txt_Label.Text}#{_ledIndex}#{C[0]}-{C[1]}-{C[2]}#";
        }
        public void SetSetting(string[] para) {
            txt_LedIndex.Text = para[3];
            RefreshLedIndex();
            try {
                string[] C = para[4].Split('-');
                Color Col = Color.FromArgb(byte.Parse(C[0]), byte.Parse(C[1]), byte.Parse(C[2]));
                label_color.BackColor = Col;
            } catch (Exception) {
            }
        }
        void RefreshLedIndex() {
            try {
                _ledIndex = int.Parse(txt_LedIndex.Text);
                txt_LedIndex.BackColor = Color.White;
            } catch (Exception) {
                txt_LedIndex.BackColor = Color.Fuchsia;
            }
        }
        void btn_Set_Low_Click(object sender, EventArgs e)
        {
            try {
                RefreshLedIndex();
                _board.ledR[_ledIndex] = 0;
                _board.ledG[_ledIndex] = 0;
                _board.ledB[_ledIndex] = 0;
                _board.SetRgbLed_MultiColor();
                btn_Set_Low.BackColor = Color.Gainsboro;
            } catch (Exception) {
                btn_Set_Low.BackColor = Color.Fuchsia;
            }
        }
        void btn_set_on_Click(object sender, EventArgs e) {
            try {
                RefreshLedIndex();
                _board.ledR[_ledIndex] = label_color.BackColor.R;
                _board.ledG[_ledIndex] = label_color.BackColor.G;
                _board.ledB[_ledIndex] = label_color.BackColor.B;
                _board.SetRgbLed_MultiColor();
                btn_set_on.BackColor = Color.Gainsboro;
            } catch (Exception) {
                btn_set_on.BackColor = Color.Fuchsia;
            }
        }


        public void WriteConfigToBoard() {
            btn_set_on_Click(null, null);
        }
        public void EditMode(bool isEditable) {
            txt_LedIndex.Enabled = isEditable;
            txt_Label.Enabled = isEditable;
        }
        public void Read(bool forceRead) {
            //do nothing
        }

        void label_color_Click(object sender, EventArgs e) {
            if (colorDialog1.ShowDialog() == DialogResult.OK) {
                label_color.BackColor = colorDialog1.Color;
            }
        }

    }
}
